	!dp = $0000
	!addr = $0000
    !rom = $800000
	!sa1 = 0
	!gsu = 0
    !sram7000 = $000000
    !sram7008 = $000000
    !ram7F9A7B = $000000
    !ram7FC700 = $000000

if read1($00FFD6) == $15
	sfxrom
	!dp = $6000
	!addr = !dp
	!gsu = 1
elseif read1($00FFD5) == $23
	sa1rom
	!dp = $3000
	!addr = $6000
	!sa1 = 1
    !rom = $000000
    !sram7000 = $2E4000
    !sram7008 = $2E6800
    !ram7F9A7B = $3E127B
    !ram7FC700 = $3DFF00
endif

;########################################
;######## Scratchs Rams [$00,$0F] #######
;########################################
!Scratch0 = $00
!Scratch1 = $01
!Scratch2 = $02
!Scratch3 = $03
!Scratch4 = $04
!Scratch5 = $05
!Scratch6 = $06
!Scratch7 = $07
!Scratch8 = $08
!Scratch9 = $09
!ScratchA = $0A
!ScratchB = $0B
!ScratchC = $0C
!ScratchD = $0D
!ScratchE = $0E
!ScratchF = $0F

;########################################
;############## Counters ################
;########################################
!TrueFrameCounter = $13
!EffectiveFrameCounter = $14

;########################################
;############## Control #################
;########################################
!ButtonPressed_BYETUDLR = $15
!ButtonDown_BYETUDLR = $16
!ButtonPressed_AXLR0000 = $17
!ButtonDown_AXLR0000 = $18

;########################################
;############## Layers ##################
;########################################
!Layer1X = $1A
!Layer1Y = $1C
!Layer2X = $1E
!Layer2Y = $20
!Layer3X = $22
!Layer3Y = $24

;########################################
;############## Player ##################
;########################################
!PlayerX = $94
!PlayerY = $96
!PlayerXSpeed = $7B
!PlayerYSpeed = $7D
!PowerUp = $19
!Lives = $0DBE|!addr
!Coins = $0DBF|!addr
!ItemBox = $0DC2|!addr
!PlayerInAirFlag = $72
!PlayerDuckingFlag = $73
!PlayerClimbingFlag_N00SIFHB = $74
!PlayerWaterFlag = $75
!PlayerDirection = $76
!PlayerBlockedStatus_S00MUDLR = $77
!PlayerHide_DLUCAPLU = $78
!CurrentPlayer = $0DB3|!addr
!CapeImage = $13DF|!addr
!PlayerPose = $13E0|!addr
!PlayerSlope = $13E1|!addr
!SpinjumpTimer = $13E2|!addr
!PlayerWallRunningFlag = $13E3|!addr
!PlayerFrozenFlag = $13FB|!addr
!PlayerCarryingFlag = $1470|!addr
!PlayerCarryingFlagImage = $148F|!addr
!PlayerAnimationTimer = $1496|!addr
!PlayerFlashingTimer = $1497|!addr
!P1PowerUp = $0DB8|!addr
!P2PowerUp = $0DB9|!addr
!P1Lives = $0DB4|!addr
!P2Lives = $0DB5|!addr
!P1Coins = $0DB6|!addr
!P2Coins = $0DB7|!addr
!P1YoshiColor = $0DBA|!addr
!P2YoshiColor = $0DBB|!addr
!P1ItemBox = $0DBC|!addr
!P2ItemBox = $0DBD|!addr

;########################################
;############### Global #################
;########################################
!LockAnimationFlag = $9D
!HScrollEnable = $1411|!addr
!VScrollEnable = $1412|!addr
!HScrollLayer2Type = $1413|!addr
!VScrollLayer2Type = $1414|!addr
!WaterFlag = $85
!SlipperyFlag = $86
!GameMode = $0100|!addr
!TwoPlayersFlag = $0DB2|!addr

;########################################
;################ OAM ###################
;########################################
!TileXPosition200 = $0200|!addr
!TileYPosition200 = $0201|!addr
!TileCode200 = $0202|!addr
!TileProperty200 = $0203|!addr
!TileSize420 = $0420|!addr
!TileXPosition = $0300|!addr
!TileYPosition = $0301|!addr
!TileCode = $0302|!addr
!TileProperty = $0303|!addr
!TileSize460 = $0460|!addr

;########################################
;############### Yoshi ##################
;########################################
!YoshiX = $18B0|!addr
!YoshiY = $18B2|!addr
!YoshiKeyInMouthFlag = $191C|!addr

;########################################
;############## Clusters ################
;########################################
!ClusterNumber = $1892|!addr
!ClusterXLow = $1E16|!addr
!ClusterYLow = $1E02|!addr
!ClusterXHigh = $1E3E|!addr
!ClusterYHigh = $1E2A|!addr
!ClusterMiscTable1 = $0F4A|!addr
!ClusterMiscTable2 = $0F5E|!addr
!ClusterMiscTable3 = $0F72|!addr
!ClusterMiscTable4 = $0F86|!addr
!ClusterMiscTable5 = $0F9A|!addr
!ClusterMiscTable6 = $1E52|!addr
!ClusterMiscTable7 = $1E66|!addr
!ClusterMiscTable8 = $1E7A|!addr
!ClusterMiscTable9 = $1E8E|!addr

;########################################
;############## Extended ################
;########################################
!ExtendedNumber = $170B|!addr
!ExtendedXLow = $171F|!addr
!ExtendedYLow = $1715|!addr
!ExtendedXHigh = $1733|!addr
!ExtendedYHigh = $1729|!addr
!ExtendedXSpeed = $1747|!addr
!ExtendedYSpeed = $173D|!addr
!ExtendedXSpeedAccumulatingFraction = $175B|!addr
!ExtendedYSpeedAccumulatingFraction = $1751|!addr
!ExtendedBehindLayersFlag = $1779|!addr
!ExtendedMiscTable1 = $1765|!addr
!ExtendedMiscTable2 = $176F|!addr

;########################################
;############### Sprites ################
;########################################
!SpriteIndex = $15E9|!addr
!SpriteNumber = $9E
!SpriteStatus = $14C8
!SpriteXLow = $E4
!SpriteYLow = $D8
!SpriteXHigh = $14E0
!SpriteYHigh = $14D4
!SpriteXSpeed = $B6
!SpriteYSpeed = $AA
!SpriteXSpeedAccumulatingFraction = $14F8
!SpriteYSpeedAccumulatingFraction = $14EC
!SpriteDirection = $157C
!SpriteBlockedStatus_ASB0UDLR = $1588
!SpriteHOffScreenFlag = $15A0
!SpriteVOffScreenFlag = $186C
!SpriteHMoreThan4TilesOffScreenFlag = $15C4
!SpriteSlope = $15B8
!SpriteYoshiTongueFlag = $15D0
!SpriteInteractionWithObjectEnable = $15DC
!SpriteIndexOAM = $15EA
!SpriteProperties_YXPPCCCT = $15F6
!SpriteLoadStatus = $161A
!SpriteBehindEscenaryFlag = $1632
!SpriteInLiquidFlag = $164A
!SpriteDecTimer1 = $1540
!SpriteDecTimer2 = $154C
!SpriteDecTimer3 = $1558
!SpriteDecTimer4 = $1564
!SpriteDecTimer5 = $15AC
!SpriteDecTimer6 = $163E
!SpriteDecTimer7 = $1FE2
!SpriteTweaker1656_SSJJCCCC = $1656
!SpriteTweaker1662_DSCCCCCC = $1662
!SpriteTweaker166E_LWCFPPPG = $166E
!SpriteTweaker167A_DPMKSPIS = $167A
!SpriteTweaker1686_DNCTSWYE = $1686
!SpriteTweaker190F_WCDJ5SDP = $190F
!SpriteMiscTable1 = $0DF5|!addr
!SpriteMiscTable2 = $0E0B|!addr
!SpriteMiscTable3 = $C2
!SpriteMiscTable4 = $1504
!SpriteMiscTable5 = $1510
!SpriteMiscTable6 = $151C
!SpriteMiscTable7 = $1528
!SpriteMiscTable8 = $1534
!SpriteMiscTable9 = $1570
!SpriteMiscTable10 = $1594
!SpriteMiscTable11 = $1602
!SpriteMiscTable12 = $160E
!SpriteMiscTable13 = $1626
!SpriteMiscTable14 = $187B
!SpriteMiscTable15 = $1FD6

;########################################
;############### GIEPY ##################
;########################################
!ExtraBits = $7FAB10
!NewCodeFlag = $7FAB1C
!ExtraProp1 = $7FAB28
!ExtraProp2 = $7FAB34
!ExtraByte1 = $7FAB40
!ExtraByte2 = $7FAB4C
!ExtraByte3 = $7FAB58
!ExtraByte4 = $7FAB64
!ShooterExtraByte = $7FAB70
!GeneratorExtraByte = $7FAB78
!ScrollerExtraByte = $7FAB79
!CustomSpriteNumber = $7FAB9E
!ShooterExtraBits = $7FABAA
!GeneratorExtraBits = $7FABB2
!Layer1ExtraBits = $7FABB3
!Layer2ExtraBits = $7FABB4
!SpriteFlags = $7FABB5

if !sa1

!SpriteNumber = $3200
!SpriteYSpeed = $9E
!SpriteXSpeed = $B6
!SpriteMiscTable3 = $D8
!SpriteYLow = $3216
!SpriteXLow = $322C
!SpriteStatus = $3242
!SpriteYHigh = $3258
!SpriteXHigh = $326E
!SpriteYSpeedAccumulatingFraction = $74C8
!SpriteXSpeedAccumulatingFraction = $74DE
!SpriteMiscTable4 = $74F4
!SpriteMiscTable5 = $750A
!SpriteMiscTable6 = $3284
!SpriteMiscTable7 = $329A
!SpriteMiscTable8 = $32B0
!SpriteDecTimer1 = $32C6
!SpriteDecTimer2 = $32DC
!SpriteDecTimer3 = $32F2
!SpriteDecTimer4 = $3308
!SpriteMiscTable9 = $331E
!SpriteDirection = $3334
!SpriteBlockedStatus_ASB0UDLR = $334A
!SpriteMiscTable10 = $3360
!SpriteHOffScreenFlag = $3376
!SpriteDecTimer5 = $338C
!SpriteSlope = $7520
!SpriteHMoreThan4TilesOffScreenFlag = $7536
!SpriteYoshiTongueFlag = $754C
!SpriteInteractionWithObjectEnable = $7562
!SpriteIndexOAM = $33A2
!SpriteProperties_YXPPCCCT = $33B8
!SpriteMiscTable11 = $33CE
!SpriteMiscTable12 = $33E4
!SpriteLoadStatus = $7578
!SpriteMiscTable13 = $758E
!SpriteBehindEscenaryFlag = $75A4
!SpriteDecTimer6 = $33FA
!SpriteInLiquidFlag = $75BA
!SpriteTweaker1656_SSJJCCCC = $75D0
!SpriteTweaker1662_DSCCCCCC = $75EA
!SpriteTweaker166E_LWCFPPPG = $7600
!SpriteTweaker167A_DPMKSPIS = $7616
!SpriteTweaker1686_DNCTSWYE = $762C
!SpriteVOffScreenFlag = $7642
!SpriteMiscTable14 = $3410
!SpriteTweaker190F_WCDJ5SDP = $7658
!SpriteMiscTable15 = $766E
!SpriteDecTimer7 = $7FD6

!ExtraBits = $400040
!NewCodeFlag = $400056
!ExtraProp1 = $400057
!ExtraProp2 = $40006D
!ExtraByte1 = $4000A4
!ExtraByte2 = $4000BA
!ExtraByte3 = $4000D0
!ExtraByte4 = $4000E6
!ShooterExtraByte = $400110
!GeneratorExtraByte = $4000FC
!ScrollerExtraByte = $4000FD
!CustomSpriteNumber = $400083
!ShooterExtraBits = $400099
!GeneratorExtraBits = $4000A1
!Layer1ExtraBits = $4000A2
!Layer2ExtraBits = $4000A3
!SpriteFlags = $400118

endif 

;######################################
;############## Defines ###############
;######################################

!FrameIndex = !SpriteMiscTable1
!AnimationTimer = !SpriteDecTimer1
!AnimationIndex = !SpriteMiscTable2
!AnimationFrameIndex = !SpriteMiscTable3
!LocalFlip = !SpriteMiscTable4
!GlobalFlip = !SpriteMiscTable5

;######################################
;########### Init Routine #############
;######################################
print "INIT ",pc
	LDA #$00
	STA !GlobalFlip,x
	JSL InitWrapperChangeAnimationFromStart
    ;Here you can write your Init Code
    ;This will be excecuted when the sprite is spawned 
RTL

;######################################
;########## Main Routine ##############
;######################################
print "MAIN ",pc
    PHB
    PHK
    PLB
    JSR SpriteCode
    PLB
RTL

;>Routine: SpriteCode
;>Description: This routine excecute the logic of the sprite
;>RoutineLength: Short
Return:
RTS
SpriteCode:

    JSR GraphicRoutine                  ;Calls the graphic routine and updates sprite graphics

    ;Here you can put code that will be excecuted each frame even if the sprite is locked

    LDA !SpriteStatus,x			        
	CMP #$08                            ;if sprite dead return
	BNE Return	

	LDA !LockAnimationFlag				    
	BNE Return			                    ;if locked animation return.

    %SubOffScreen()

    JSR InteractMarioSprite
    ;After this routine, if the sprite interact with mario, Carry is Set.

    ;Here you can write your sprite code routine
    ;This will be excecuted once per frame excepts when 
    ;the animation is locked or when sprite status is not #$08

    JSR AnimationRoutine                ;Calls animation routine and decides the next frame to draw
    
    RTS

;>EndRoutine

;######################################
;######## Sub Routine Space ###########
;######################################

;Here you can write routines or tables

;Don't Delete or write another >Section Graphics or >End Section
;All code between >Section Graphics and >End Graphics Section will be changed by Dyzen : Sprite Maker
;>Section Graphics
;######################################
;########## Graphics Space ############
;######################################

;This space is for routines used for graphics
;if you don't know enough about asm then
;don't edit them.

;>Routine: GraphicRoutine
;>Description: Updates tiles on the oam map
;results will be visible the next frame.
;>RoutineLength: Short
GraphicRoutine:

    %GetDrawInfo()                     ;Calls GetDrawInfo to get the free slot and the XDisp and YDisp

    STZ !Scratch3                       ;$02 = Free Slot but in 16bits
    STY !Scratch2


    STZ !Scratch5
    LDA !GlobalFlip,x   
    ASL
    STA !Scratch4                       ;$04 = Global Flip but in 16bits


    PHX                                 ;Preserve X
    
    STZ !Scratch7
    LDA !FrameIndex,x
    STA !Scratch6                       ;$06 = Frame Index but in 16bits

    REP #$30                            ;A/X/Y 16bits mode
    LDY !Scratch4                       ;Y = Global Flip
    LDA !Scratch6
    ASL
	CLC
    ADC FramesFlippers,y
    TAX                                 ;X = Frame Index

    LDA FramesLength,x
    CMP #$FFFF
    BNE +
    SEP #$30
    PLX
    RTS
+
    STA !Scratch8

    LDA FramesEndPosition,x
    STA !Scratch4                       ;$04 = End Position + A value used to select a frame version that is flipped

    LDA FramesStartPosition,x           
    TAX                                 ;X = Start Position
    SEP #$20                            ;A 8bits mode
    LDY !Scratch2                       ;Y = Free Slot
    CPY #$00FD
    BCS .return                         ;Y can't be more than #$00FD
-
    LDA Tiles,x
    STA !TileCode,y                     ;Set the Tile code of the tile Y

    LDA Properties,x
    STA !TileProperty,y                 ;Set the Tile property of the tile Y

    LDA !Scratch0
	CLC
	ADC XDisplacements,x
	STA !TileXPosition,y                ;Set the Tile x pos of the tile Y

    LDA !Scratch1
	CLC
	ADC YDisplacements,x
	STA !TileYPosition,y                ;Set the Tile y pos of the tile Y

    INY
    INY
    INY
    INY                                 ;Next OAM Slot
    CPY #$00FD
    BCS .return                         ;Y can't be more than #$00FD

    DEX
    BMI .return
    CPX !Scratch4                       ;if X < start position or is negative then return
    BCS -                               ;else loop

.return
    SEP #$10
    PLX                                 ;Restore X
    
	LDY #$02
    LDA !Scratch8                       ;Load the number of tiles used by the frame
    JSL $01B7B3|!rom                  		;This insert the new tiles into the oam, 
                                        ;A = #$00 => only tiles of 8x8, A = #$02 = only tiles of 16x16, A = #$04 = tiles of 8x8 or 16x16
                                        ;if you select A = #$04 then you must put the sizes of the tiles in !TileSize
RTS
;>EndRoutine

;All words that starts with '@' and finish with '.' will be replaced by Dyzen

;>Table: FramesLengths
;>Description: How many tiles use each frame.
;>ValuesSize: 16
FramesLength:
    dw $0004,$0004,$0004,$0004,$0004,$0004,$0004,$0004,$0004,$0004,$0003,$0003,$0003,$0003,$0003,$0003
	dw $0003,$0003,$0003,$0003,$0003,$0000,$0000
	dw $0004,$0004,$0004,$0004,$0004,$0004,$0004,$0004,$0004,$0004,$0003,$0003,$0003,$0003,$0003,$0003
	dw $0003,$0003,$0003,$0003,$0003,$0000,$0000
;>EndTable


;>Table: FramesFlippers
;>Description: Values used to add values to FramesStartPosition and FramesEndPosition
;To use a flipped version of the frames.
;>ValuesSize: 16
FramesFlippers:
    dw $0000,$002E
;>EndTable


;>Table: FramesStartPosition
;>Description: Indicates the index where starts each frame
;>ValuesSize: 16
FramesStartPosition:
    dw $0004,$0009,$000E,$0013,$0018,$001D,$0022,$0027,$002C,$0031,$0035,$0039,$003D,$0041,$0045,$0049
	dw $004D,$0051,$0055,$0059,$005D,$005E,$005F
	dw $0064,$0069,$006E,$0073,$0078,$007D,$0082,$0087,$008C,$0091,$0095,$0099,$009D,$00A1,$00A5,$00A9
	dw $00AD,$00B1,$00B5,$00B9,$00BD,$00BE,$00BF
;>EndTable

;>Table: FramesEndPosition
;>Description: Indicates the index where end each frame
;>ValuesSize: 16
FramesEndPosition:
    dw $0000,$0005,$000A,$000F,$0014,$0019,$001E,$0023,$0028,$002D,$0032,$0036,$003A,$003E,$0042,$0046
	dw $004A,$004E,$0052,$0056,$005A,$005E,$005F
	dw $0060,$0065,$006A,$006F,$0074,$0079,$007E,$0083,$0088,$008D,$0092,$0096,$009A,$009E,$00A2,$00A6
	dw $00AA,$00AE,$00B2,$00B6,$00BA,$00BE,$00BF
;>EndTable


;>Table: Tiles
;>Description: Tiles codes of each tile of each frame
;>ValuesSize: 8
Tiles:
    
Frame0_Stand1_Tiles:
	db $00,$20,$01,$21,$4E
Frame1_Stand2_Tiles:
	db $03,$23,$04,$24,$6E
Frame2_Walk1_Tiles:
	db $06,$26,$08,$28,$4E
Frame3_Walk2_Tiles:
	db $0A,$2A,$0B,$2B,$6E
Frame4_Walk3_Tiles:
	db $0D,$2D,$0E,$2E,$4E
Frame5_Walk4_Tiles:
	db $50,$60,$51,$61,$6E
Frame6_Walk5_Tiles:
	db $43,$63,$44,$64,$4E
Frame7_Walk6_Tiles:
	db $46,$66,$47,$67,$6E
Frame8_Jump_Tiles:
	db $49,$69,$4B,$6B,$4E
Frame9_RollingCutter1_Tiles:
	db $80,$A0,$81,$A1,$4E
Frame10_RollingCutter2_Tiles:
	db $83,$A3,$85,$A5
Frame11_StandNoCutter1_Tiles:
	db $00,$20,$01,$21
Frame12_StandNoCutter2_Tiles:
	db $03,$23,$04,$24
Frame13_WalkNoCutter1_Tiles:
	db $06,$26,$08,$28
Frame14_WalkNoCutter2_Tiles:
	db $0A,$2A,$0B,$2B
Frame15_WalkNoCutter3_Tiles:
	db $0D,$2D,$0E,$2E
Frame16_WalkNoCutter4_Tiles:
	db $50,$60,$51,$61
Frame17_WalkNoCutter5_Tiles:
	db $43,$63,$44,$64
Frame18_WalkNoCutter6_Tiles:
	db $46,$66,$47,$67
Frame19_JumpNoCutter_Tiles:
	db $49,$69,$4B,$6B
Frame20_Hit_Tiles:
	db $C8,$E8,$C8,$E8
Frame21_Death1_Tiles:
	db $C0
Frame22_Death2_Tiles:
	db $E0
Frame0_Stand1_TilesFlipX:
	db $00,$20,$01,$21,$4E
Frame1_Stand2_TilesFlipX:
	db $03,$23,$04,$24,$6E
Frame2_Walk1_TilesFlipX:
	db $06,$26,$08,$28,$4E
Frame3_Walk2_TilesFlipX:
	db $0A,$2A,$0B,$2B,$6E
Frame4_Walk3_TilesFlipX:
	db $0D,$2D,$0E,$2E,$4E
Frame5_Walk4_TilesFlipX:
	db $50,$60,$51,$61,$6E
Frame6_Walk5_TilesFlipX:
	db $43,$63,$44,$64,$4E
Frame7_Walk6_TilesFlipX:
	db $46,$66,$47,$67,$6E
Frame8_Jump_TilesFlipX:
	db $49,$69,$4B,$6B,$4E
Frame9_RollingCutter1_TilesFlipX:
	db $80,$A0,$81,$A1,$4E
Frame10_RollingCutter2_TilesFlipX:
	db $83,$A3,$85,$A5
Frame11_StandNoCutter1_TilesFlipX:
	db $00,$20,$01,$21
Frame12_StandNoCutter2_TilesFlipX:
	db $03,$23,$04,$24
Frame13_WalkNoCutter1_TilesFlipX:
	db $06,$26,$08,$28
Frame14_WalkNoCutter2_TilesFlipX:
	db $0A,$2A,$0B,$2B
Frame15_WalkNoCutter3_TilesFlipX:
	db $0D,$2D,$0E,$2E
Frame16_WalkNoCutter4_TilesFlipX:
	db $50,$60,$51,$61
Frame17_WalkNoCutter5_TilesFlipX:
	db $43,$63,$44,$64
Frame18_WalkNoCutter6_TilesFlipX:
	db $46,$66,$47,$67
Frame19_JumpNoCutter_TilesFlipX:
	db $49,$69,$4B,$6B
Frame20_Hit_TilesFlipX:
	db $C8,$E8,$C8,$E8
Frame21_Death1_TilesFlipX:
	db $C0
Frame22_Death2_TilesFlipX:
	db $E0
;>EndTable


;>Table: Properties
;>Description: Properties of each tile of each frame
;>ValuesSize: 8
Properties:
    
Frame0_Stand1_Properties:
	db $2B,$2B,$2B,$2B,$2B
Frame1_Stand2_Properties:
	db $2B,$2B,$2B,$2B,$2B
Frame2_Walk1_Properties:
	db $2B,$2B,$2B,$2B,$2B
Frame3_Walk2_Properties:
	db $2B,$2B,$2B,$2B,$2B
Frame4_Walk3_Properties:
	db $2B,$2B,$2B,$2B,$2B
Frame5_Walk4_Properties:
	db $2B,$2B,$2B,$2B,$2B
Frame6_Walk5_Properties:
	db $2B,$2B,$2B,$2B,$2B
Frame7_Walk6_Properties:
	db $2B,$2B,$2B,$2B,$2B
Frame8_Jump_Properties:
	db $2B,$2B,$2B,$2B,$2B
Frame9_RollingCutter1_Properties:
	db $2B,$2B,$2B,$2B,$2B
Frame10_RollingCutter2_Properties:
	db $2B,$2B,$2B,$2B
Frame11_StandNoCutter1_Properties:
	db $2B,$2B,$2B,$2B
Frame12_StandNoCutter2_Properties:
	db $2B,$2B,$2B,$2B
Frame13_WalkNoCutter1_Properties:
	db $2B,$2B,$2B,$2B
Frame14_WalkNoCutter2_Properties:
	db $2B,$2B,$2B,$2B
Frame15_WalkNoCutter3_Properties:
	db $2B,$2B,$2B,$2B
Frame16_WalkNoCutter4_Properties:
	db $2B,$2B,$2B,$2B
Frame17_WalkNoCutter5_Properties:
	db $2B,$2B,$2B,$2B
Frame18_WalkNoCutter6_Properties:
	db $2B,$2B,$2B,$2B
Frame19_JumpNoCutter_Properties:
	db $2B,$2B,$2B,$2B
Frame20_Hit_Properties:
	db $2B,$2B,$6B,$6B
Frame21_Death1_Properties:
	db $2B
Frame22_Death2_Properties:
	db $2B
Frame0_Stand1_PropertiesFlipX:
	db $6B,$6B,$6B,$6B,$6B
Frame1_Stand2_PropertiesFlipX:
	db $6B,$6B,$6B,$6B,$6B
Frame2_Walk1_PropertiesFlipX:
	db $6B,$6B,$6B,$6B,$6B
Frame3_Walk2_PropertiesFlipX:
	db $6B,$6B,$6B,$6B,$6B
Frame4_Walk3_PropertiesFlipX:
	db $6B,$6B,$6B,$6B,$6B
Frame5_Walk4_PropertiesFlipX:
	db $6B,$6B,$6B,$6B,$6B
Frame6_Walk5_PropertiesFlipX:
	db $6B,$6B,$6B,$6B,$6B
Frame7_Walk6_PropertiesFlipX:
	db $6B,$6B,$6B,$6B,$6B
Frame8_Jump_PropertiesFlipX:
	db $6B,$6B,$6B,$6B,$6B
Frame9_RollingCutter1_PropertiesFlipX:
	db $6B,$6B,$6B,$6B,$6B
Frame10_RollingCutter2_PropertiesFlipX:
	db $6B,$6B,$6B,$6B
Frame11_StandNoCutter1_PropertiesFlipX:
	db $6B,$6B,$6B,$6B
Frame12_StandNoCutter2_PropertiesFlipX:
	db $6B,$6B,$6B,$6B
Frame13_WalkNoCutter1_PropertiesFlipX:
	db $6B,$6B,$6B,$6B
Frame14_WalkNoCutter2_PropertiesFlipX:
	db $6B,$6B,$6B,$6B
Frame15_WalkNoCutter3_PropertiesFlipX:
	db $6B,$6B,$6B,$6B
Frame16_WalkNoCutter4_PropertiesFlipX:
	db $6B,$6B,$6B,$6B
Frame17_WalkNoCutter5_PropertiesFlipX:
	db $6B,$6B,$6B,$6B
Frame18_WalkNoCutter6_PropertiesFlipX:
	db $6B,$6B,$6B,$6B
Frame19_JumpNoCutter_PropertiesFlipX:
	db $6B,$6B,$6B,$6B
Frame20_Hit_PropertiesFlipX:
	db $6B,$6B,$2B,$2B
Frame21_Death1_PropertiesFlipX:
	db $6B
Frame22_Death2_PropertiesFlipX:
	db $6B
;>EndTable
;>Table: XDisplacements
;>Description: X Displacement of each tile of each frame
;>ValuesSize: 8
XDisplacements:
    
Frame0_Stand1_XDisp:
	db $FC,$FC,$04,$04,$01
Frame1_Stand2_XDisp:
	db $FC,$FC,$04,$04,$01
Frame2_Walk1_XDisp:
	db $F8,$F8,$08,$08,$FD
Frame3_Walk2_XDisp:
	db $FC,$FC,$04,$04,$FD
Frame4_Walk3_XDisp:
	db $FC,$FC,$04,$04,$FD
Frame5_Walk4_XDisp:
	db $FC,$FC,$04,$04,$FD
Frame6_Walk5_XDisp:
	db $FC,$FC,$04,$04,$FD
Frame7_Walk6_XDisp:
	db $FC,$FC,$04,$04,$FD
Frame8_Jump_XDisp:
	db $F8,$F8,$08,$08,$FF
Frame9_RollingCutter1_XDisp:
	db $FB,$FB,$03,$03,$01
Frame10_RollingCutter2_XDisp:
	db $F2,$F2,$02,$02
Frame11_StandNoCutter1_XDisp:
	db $FC,$FC,$04,$04
Frame12_StandNoCutter2_XDisp:
	db $FC,$FC,$04,$04
Frame13_WalkNoCutter1_XDisp:
	db $F8,$F8,$08,$08
Frame14_WalkNoCutter2_XDisp:
	db $FC,$FC,$04,$04
Frame15_WalkNoCutter3_XDisp:
	db $FC,$FC,$04,$04
Frame16_WalkNoCutter4_XDisp:
	db $FC,$FC,$04,$04
Frame17_WalkNoCutter5_XDisp:
	db $FC,$FC,$04,$04
Frame18_WalkNoCutter6_XDisp:
	db $FC,$FC,$04,$04
Frame19_JumpNoCutter_XDisp:
	db $F8,$F8,$08,$08
Frame20_Hit_XDisp:
	db $F8,$F8,$08,$08
Frame21_Death1_XDisp:
	db $00
Frame22_Death2_XDisp:
	db $00
Frame0_Stand1_XDispFlipX:
	db $04,$04,$FC,$FC,$FF
Frame1_Stand2_XDispFlipX:
	db $04,$04,$FC,$FC,$FF
Frame2_Walk1_XDispFlipX:
	db $08,$08,$F8,$F8,$03
Frame3_Walk2_XDispFlipX:
	db $04,$04,$FC,$FC,$03
Frame4_Walk3_XDispFlipX:
	db $04,$04,$FC,$FC,$03
Frame5_Walk4_XDispFlipX:
	db $04,$04,$FC,$FC,$03
Frame6_Walk5_XDispFlipX:
	db $04,$04,$FC,$FC,$03
Frame7_Walk6_XDispFlipX:
	db $04,$04,$FC,$FC,$03
Frame8_Jump_XDispFlipX:
	db $08,$08,$F8,$F8,$01
Frame9_RollingCutter1_XDispFlipX:
	db $05,$05,$FD,$FD,$FF
Frame10_RollingCutter2_XDispFlipX:
	db $0E,$0E,$FE,$FE
Frame11_StandNoCutter1_XDispFlipX:
	db $04,$04,$FC,$FC
Frame12_StandNoCutter2_XDispFlipX:
	db $04,$04,$FC,$FC
Frame13_WalkNoCutter1_XDispFlipX:
	db $08,$08,$F8,$F8
Frame14_WalkNoCutter2_XDispFlipX:
	db $04,$04,$FC,$FC
Frame15_WalkNoCutter3_XDispFlipX:
	db $04,$04,$FC,$FC
Frame16_WalkNoCutter4_XDispFlipX:
	db $04,$04,$FC,$FC
Frame17_WalkNoCutter5_XDispFlipX:
	db $04,$04,$FC,$FC
Frame18_WalkNoCutter6_XDispFlipX:
	db $04,$04,$FC,$FC
Frame19_JumpNoCutter_XDispFlipX:
	db $08,$08,$F8,$F8
Frame20_Hit_XDispFlipX:
	db $08,$08,$F8,$F8
Frame21_Death1_XDispFlipX:
	db $00
Frame22_Death2_XDispFlipX:
	db $00
;>EndTable
;>Table: YDisplacements
;>Description: Y Displacement of each tile of each frame
;>ValuesSize: 8
YDisplacements:
    
Frame0_Stand1_YDisp:
	db $F0,$00,$F0,$00,$E7
Frame1_Stand2_YDisp:
	db $F0,$00,$F0,$00,$E7
Frame2_Walk1_YDisp:
	db $F0,$00,$F0,$00,$E9
Frame3_Walk2_YDisp:
	db $F0,$00,$F0,$00,$E6
Frame4_Walk3_YDisp:
	db $F0,$00,$F0,$00,$E7
Frame5_Walk4_YDisp:
	db $F8,$00,$F8,$00,$E9
Frame6_Walk5_YDisp:
	db $F0,$00,$F0,$00,$E6
Frame7_Walk6_YDisp:
	db $F0,$00,$F0,$00,$E7
Frame8_Jump_YDisp:
	db $F0,$00,$F0,$00,$E8
Frame9_RollingCutter1_YDisp:
	db $F0,$00,$F0,$00,$E7
Frame10_RollingCutter2_YDisp:
	db $F0,$00,$F0,$00
Frame11_StandNoCutter1_YDisp:
	db $F0,$00,$F0,$00
Frame12_StandNoCutter2_YDisp:
	db $F0,$00,$F0,$00
Frame13_WalkNoCutter1_YDisp:
	db $F0,$00,$F0,$00
Frame14_WalkNoCutter2_YDisp:
	db $F0,$00,$F0,$00
Frame15_WalkNoCutter3_YDisp:
	db $F0,$00,$F0,$00
Frame16_WalkNoCutter4_YDisp:
	db $F8,$00,$F8,$00
Frame17_WalkNoCutter5_YDisp:
	db $F0,$00,$F0,$00
Frame18_WalkNoCutter6_YDisp:
	db $F0,$00,$F0,$00
Frame19_JumpNoCutter_YDisp:
	db $F0,$00,$F0,$00
Frame20_Hit_YDisp:
	db $F0,$00,$F0,$00
Frame21_Death1_YDisp:
	db $00
Frame22_Death2_YDisp:
	db $00
Frame0_Stand1_YDispFlipX:
	db $F0,$00,$F0,$00,$E7
Frame1_Stand2_YDispFlipX:
	db $F0,$00,$F0,$00,$E7
Frame2_Walk1_YDispFlipX:
	db $F0,$00,$F0,$00,$E9
Frame3_Walk2_YDispFlipX:
	db $F0,$00,$F0,$00,$E6
Frame4_Walk3_YDispFlipX:
	db $F0,$00,$F0,$00,$E7
Frame5_Walk4_YDispFlipX:
	db $F8,$00,$F8,$00,$E9
Frame6_Walk5_YDispFlipX:
	db $F0,$00,$F0,$00,$E6
Frame7_Walk6_YDispFlipX:
	db $F0,$00,$F0,$00,$E7
Frame8_Jump_YDispFlipX:
	db $F0,$00,$F0,$00,$E8
Frame9_RollingCutter1_YDispFlipX:
	db $F0,$00,$F0,$00,$E7
Frame10_RollingCutter2_YDispFlipX:
	db $F0,$00,$F0,$00
Frame11_StandNoCutter1_YDispFlipX:
	db $F0,$00,$F0,$00
Frame12_StandNoCutter2_YDispFlipX:
	db $F0,$00,$F0,$00
Frame13_WalkNoCutter1_YDispFlipX:
	db $F0,$00,$F0,$00
Frame14_WalkNoCutter2_YDispFlipX:
	db $F0,$00,$F0,$00
Frame15_WalkNoCutter3_YDispFlipX:
	db $F0,$00,$F0,$00
Frame16_WalkNoCutter4_YDispFlipX:
	db $F8,$00,$F8,$00
Frame17_WalkNoCutter5_YDispFlipX:
	db $F0,$00,$F0,$00
Frame18_WalkNoCutter6_YDispFlipX:
	db $F0,$00,$F0,$00
Frame19_JumpNoCutter_YDispFlipX:
	db $F0,$00,$F0,$00
Frame20_Hit_YDispFlipX:
	db $F0,$00,$F0,$00
Frame21_Death1_YDispFlipX:
	db $00
Frame22_Death2_YDispFlipX:
	db $00
;>EndTable
;>End Graphics Section

;Don't Delete or write another >Section Animation or >End Section
;All code between >Section Animations and >End Animations Section will be changed by Dyzen : Sprite Maker
;>Section Animations
;######################################
;########## Animation Space ###########
;######################################

;This space is for routines used for graphics
;if you don't know enough about asm then
;don't edit them.
InitWrapperChangeAnimationFromStart:
	PHB
    PHK
    PLB
	STZ !AnimationIndex,x
	JSR ChangeAnimationFromStart
	PLB
	RTL

ChangeAnimationFromStart_Stand:
	STZ !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Walk:
	LDA #$01
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Jump:
	LDA #$02
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_RollingCutter:
	LDA #$03
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Damage:
	LDA #$04
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_StandNoCutter:
	LDA #$05
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_WalkNoCutter:
	LDA #$06
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_JumpNoCutter:
	LDA #$07
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_DamageNoCutter:
	LDA #$08
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Hit:
	LDA #$09
	STA !AnimationIndex,x
	JMP ChangeAnimationFromStart
ChangeAnimationFromStart_Death:
	LDA #$0A
	STA !AnimationIndex,x


ChangeAnimationFromStart:
	STZ !AnimationFrameIndex,x

	STZ !Scratch1
	LDA !AnimationIndex,x
	STA !Scratch0					;$00 = Animation index in 16 bits

	STZ !Scratch3
	LDA !AnimationFrameIndex,x
	STA !Scratch2					;$02 = Animation Frame index in 16 bits

	STZ !Scratch5
	STX !Scratch4					;$04 = sprite index in 16 bits

	REP #$30						;A7X/Y of 16 bits
	LDX !Scratch4					;X = sprite index in 16 bits

	LDA !Scratch0
	ASL
	TAY								;Y = 2*Animation index

	LDA !Scratch2
	CLC
	ADC AnimationIndexer,y
	TAY								;Y = Position of the first frame of the animation + animation frame index

	SEP #$20						;A of 8 bits

	LDA Frames,y
	STA !FrameIndex,x				;New Frame = Frames[New Animation Frame Index]

	LDA Times,y
	STA !AnimationTimer,x			;Time = Times[New Animation Frame Index]

	LDA !Scratch2
	STA !AnimationFrameIndex,x

	SEP #$10						;X/Y of 8 bits
	LDX !Scratch4					;X = sprite index in 8 bits
RTS
	

;>Routine: AnimationRoutine
;>Description: Decides what will be the next frame.
;>RoutineLength: Short
AnimationRoutine:
    LDA !AnimationTimer,x
    BEQ +

	RTS

+
	STZ !Scratch1
	LDA !AnimationIndex,x
	STA !Scratch0					;$00 = Animation index in 16 bits

	STZ !Scratch3
	LDA !AnimationFrameIndex,x
	STA !Scratch2					;$02 = Animation Frame index in 16 bits

	STZ !Scratch5
	STX !Scratch4					;$04 = sprite index in 16 bits

	REP #$30						;A7X/Y of 16 bits
	LDX !Scratch4					;X = sprite index in 16 bits

	LDA !Scratch0
	ASL
	TAY								;Y = 2*Animation index

	INC !Scratch2					;New Animation Frame Index = Animation Frame Index + 1

	LDA !Scratch2			        ;if Animation Frame index < Animation Lenght then Animation Frame index++
	CMP AnimationLenght,y			;else go to the frame where start the loop.
	BCC +							

	LDA AnimationLastTransition,y
	STA !Scratch2					;New Animation Frame Index = first frame of the loop.

+
	LDA !Scratch2
	CLC
	ADC AnimationIndexer,y
	TAY								;Y = Position of the first frame of the animation + animation frame index

	SEP #$20						;A of 8 bits

	LDA Frames,y
	STA !FrameIndex,x				;New Frame = Frames[New Animation Frame Index]

	LDA Times,y
	STA !AnimationTimer,x			;Time = Times[New Animation Frame Index]

	LDA !Scratch2
	STA !AnimationFrameIndex,x

	SEP #$10						;X/Y of 8 bits
	LDX !Scratch4					;X = sprite index in 8 bits
RTS
;>EndRoutine

;All words that starts with '>' and finish with '.' will be replaced by Dyzen

AnimationLenght:
	dw $0002,$0006,$0001,$0002,$0001,$0002,$0006,$0001,$0001,$0001,$0002

AnimationLastTransition:
	dw $0000,$0000,$0000,$0001,$0000,$0000,$0000,$0000,$0000,$0000,$0000

AnimationIndexer:
	dw $0000,$0002,$0008,$0009,$000B,$000C,$000E,$0014,$0015,$0016,$0017

Frames:
	
Animation0_Stand_Frames:
	db $00,$01
Animation1_Walk_Frames:
	db $02,$03,$04,$05,$06,$07
Animation2_Jump_Frames:
	db $08
Animation3_RollingCutter_Frames:
	db $09,$0A
Animation4_Damage_Frames:
	db $03
Animation5_StandNoCutter_Frames:
	db $0B,$0C
Animation6_WalkNoCutter_Frames:
	db $0D,$0E,$0F,$10,$11,$12
Animation7_JumpNoCutter_Frames:
	db $13
Animation8_DamageNoCutter_Frames:
	db $0E
Animation9_Hit_Frames:
	db $14
Animation10_Death_Frames:
	db $15,$16

Times:
	
Animation0_Stand_Times:
	db $04,$04
Animation1_Walk_Times:
	db $04,$04,$04,$04,$04,$04
Animation2_Jump_Times:
	db $04
Animation3_RollingCutter_Times:
	db $04,$14
Animation4_Damage_Times:
	db $1E
Animation5_StandNoCutter_Times:
	db $04,$04
Animation6_WalkNoCutter_Times:
	db $04,$04,$04,$04,$04,$04
Animation7_JumpNoCutter_Times:
	db $04
Animation8_DamageNoCutter_Times:
	db $1E
Animation9_Hit_Times:
	db $04
Animation10_Death_Times:
	db $02,$02
;>End Animations Section

;Don't Delete or write another >Section Hitbox Interaction or >End Section
;All code between >Section Hitboxes Interaction and >End Hitboxes Interaction Section will be changed by Dyzen : Sprite Maker
;>Section Hitboxes Interaction
;######################################
;######## Interaction Space ###########
;######################################

InteractMarioSprite:
	LDA !SpriteTweaker167A_DPMKSPIS,x
	AND #$20
	BNE ProcessInteract      
	TXA                       
	EOR !TrueFrameCounter      			
	AND #$01                	
	ORA !SpriteHOffScreenFlag,x 				
	BEQ ProcessInteract       
ReturnNoContact:
	CLC                       
	RTS
ProcessInteract:
	%SubHorzPos()
	LDA !ScratchF                  
	CLC                       
	ADC #$50                
	CMP #$A0                
	BCS ReturnNoContact       ; No contact, return 
	%SubVertPos()         
	LDA !ScratchE                   
	CLC                       
	ADC #$60                
	CMP #$C0                
	BCS ReturnNoContact       ; No contact, return 
	LDA $71    ; \ If animation sequence activated... 
	CMP #$01                ;  | 
	BCS ReturnNoContact       ; / ...no contact, return 
	LDA #$00                ; \ Branch if bit 6 of $0D9B set? 
	BIT $0D9B|!addr               ;  | 
	BVS +           ; / 
	LDA $13F9|!addr ; \ If Mario and Sprite not on same side of scenery... 
	EOR !SpriteBehindEscenaryFlag,x ;  |
+
	BNE ReturnNoContact2
	JSL $03B664|!rom				; MarioClipping
	JSR Interaction

	BCC ReturnNoContact2
	LDA !ScratchE
	CMP #$01
	BNE +
	JSR DefaultAction
+
	SEC
	RTS
ReturnNoContact2:
	CLC
	RTS

Interaction:
    STZ !ScratchE
	LDA !GlobalFlip,x
    ASL
	TAY                     ;Y = Flip Adder, used to jump to the frame with the current flip

    LDA !FrameIndex,x
	STA !Scratch4
	STZ !Scratch5

    REP #$20
	LDA !Scratch4
	ASL
	CLC
	ADC HitboxAdder,y
	REP #$10
	TAY

    LDA FrameHitboxesIndexer,y
    TAY
    SEP #$20

-
    LDA FrameHitBoxes,y
    CMP #$FF
    BNE +
    LDA !ScratchE
    BNE ++
	SEP #$10
	LDX !SpriteIndex
    CLC
    RTS
++
	SEP #$10
	LDX !SpriteIndex
    SEC
    RTS
+
    STA !Scratch4
    STZ !Scratch5
    PHY

    REP #$20
    LDA !Scratch4
    ASL
    TAY

    LDA HitboxesStart,y
    TAY
    SEP #$20

	LDA !ScratchE
	AND #$01
	BEQ +

	LDA Hitboxes+5,y
	BNE +

	PLY
    INY
	BRA -

+

	STZ !ScratchA
    LDA Hitboxes+1,y
    STA !Scratch4           ;$04 = Low X Offset
    BPL +
    LDA #$FF
    STA !ScratchA           ;$0A = High X offset
+

	STZ !ScratchB
    LDA Hitboxes+2,y
    STA !Scratch5           ;$05 = Low Y Offset
    BPL +
    LDA #$FF
    STA !ScratchB           ;$0B = High Y Offset
+

    LDA Hitboxes+3,y
    STA !Scratch6           ;$06 = Width

    LDA Hitboxes+4,y
    STA !Scratch7           ;$07 = Height

	PHY
	SEP #$10
	LDX !SpriteIndex

	LDA !SpriteXHigh,x
	XBA
	LDA !SpriteXLow,x
	REP #$20
	PHA
	SEP #$20

	LDA !ScratchA
	XBA
	LDA !Scratch4
	REP #$20
	CLC
	ADC $01,s
	PHA
	SEP #$20
	PLA 
	STA !Scratch4
	PLA
	STA !ScratchA
	PLA
	PLA

	LDA !SpriteYHigh,x
	XBA
	LDA !SpriteYLow,x
	REP #$20
	PHA
	SEP #$20

	LDA !ScratchB
	XBA
	LDA !Scratch5
	REP #$20
	CLC
	ADC $01,s
	PHA
	SEP #$20
	PLA 
	STA !Scratch5
	PLA
	STA !ScratchB
	PLA
	PLA

    JSL $03B72B|!rom
	REP #$10
	BCS ++
	PLY
	BRA +
++
	PLY

    LDA Hitboxes+5,y
	BNE ++

	LDA !ScratchE
	ORA #$01
    STA !ScratchE
	PLY
    INY
    JMP -

++

    STA !ScratchC
    STZ !ScratchD
    REP #$20
    LDA !ScratchC
    ASL
    TAY

    LDA Actions,y
    STA !ScratchC
    SEP #$30
	LDX #$00
    JSR ($000C|!dp,x)
    REP #$10
+
    PLY
    INY
    JMP -


HitboxAdder:
    dw $0000,$002E

FrameHitboxesIndexer:
    dw $0000,$0002,$0004,$0006,$0008,$000A,$000C,$000E,$0010,$0012,$0014,$0016,$0018,$001A,$001C,$001E
	dw $0020,$0022,$0024,$0026,$0028,$0029,$002A
	dw $002B,$002D,$002F,$0031,$0033,$0035,$0037,$0039,$003B,$003D,$003F,$0041,$0043,$0045,$0047,$0049
	dw $004B,$004D,$004F,$0051,$0053,$0054,$0055

FrameHitBoxes:
    db $00,$FF
	db $00,$FF
	db $00,$FF
	db $00,$FF
	db $00,$FF
	db $00,$FF
	db $00,$FF
	db $00,$FF
	db $00,$FF
	db $00,$FF
	db $01,$FF
	db $02,$FF
	db $02,$FF
	db $03,$FF
	db $04,$FF
	db $05,$FF
	db $03,$FF
	db $04,$FF
	db $05,$FF
	db $06,$FF
	db $FF
	db $FF
	db $FF
	
	db $07,$FF
	db $07,$FF
	db $07,$FF
	db $07,$FF
	db $07,$FF
	db $07,$FF
	db $07,$FF
	db $07,$FF
	db $07,$FF
	db $07,$FF
	db $08,$FF
	db $09,$FF
	db $09,$FF
	db $0A,$FF
	db $0B,$FF
	db $0C,$FF
	db $0A,$FF
	db $0B,$FF
	db $0C,$FF
	db $0D,$FF
	db $FF
	db $FF
	db $FF
	

HitboxesStart:
    dw $0000,$0006,$000C,$0012,$0018,$001E,$0024,$002A,$0030,$0036,$003C,$0042,$0048,$004E

Hitboxes:
    db $01,$00,$F0,$10,$20,$01
	db $01,$FD,$F6,$10,$1A,$02
	db $01,$01,$F6,$10,$1A,$02
	db $01,$FF,$F8,$10,$18,$02
	db $01,$FF,$F5,$10,$1B,$02
	db $01,$FF,$F6,$10,$1A,$02
	db $01,$00,$F7,$10,$19,$02
	db $01,$00,$F0,$10,$20,$01
	db $01,$03,$F6,$10,$1A,$02
	db $01,$FF,$F6,$10,$1A,$02
	db $01,$01,$F8,$10,$18,$02
	db $01,$01,$F5,$10,$1B,$02
	db $01,$01,$F6,$10,$1A,$02
	db $01,$00,$F7,$10,$19,$02
	

Actions:
    dw DefaultAction
	dw MarioDamage
	dw CutManDamage
	

;This routine will be executed when mario interact with a standar hitbox.
;It will be excecuted if $0E is 1 after execute Interaction routine
DefaultAction:
RTS
    
;>End Hitboxes Interaction Section

;>Action
;### Action MarioDamage ###
MarioDamage:
	LDX !SpriteIndex
;Here you can write your action code
RTS
;>End Action

;>Action
;### Action CutManDamage ###
CutManDamage:
	LDX !SpriteIndex
;Here you can write your action code
RTS
;>End Action
